/* dosshell.c: A simple DOS shell program */

#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <direct.h>
#include <string.h>
#include <graph.h>
#include "textscrn.h"
#include "popup.h"


/* Application screen descriptor */
POPUP scrn = {1, 1, 25, 80, 0, YELLOW, MAGENTA, BLACK, CYAN};

/* DOS screen descriptor */
POPUP dos = {1, 1, 25, 80, 0, LTGRAY, 0, BLACK};

/* Popup descriptor for command line arguments */
POPUP arg = {22, 2, 22, 79, 1, RED, 0, BLACK, 0};

/* POPUP descriptor for current directory */
POPUP dir = {3, 1, 3, 1, 2, MAGENTA, 0, BLACK, 0};

/* List of commands */
char cmd [][16] = {
{"CHDIR"}, {"COPY"},  {"DATE"},         {"DEL"},
{"DIR"},   {"MKDIR"}, {"RENAME"},       {"SET"},
{"TIME"},  {"TYPE"},  {"Command line"}, {"Quit"}
};


/* Local functions */
void buildScreen (void);
void processCommand (int);
char *getargs (int);
char *noargs (int);
void showdir (void);

/*--------------------------------------------*/

void main()
{
	int curdrive, choice, n;
	char curdir [64], oldpath [67], entry [3];

	/* Get current drive and directory */
	_dos_getdrive (&curdrive);
	getcwd (curdir, 64);

	/* Set up screen */
	_savescrn (0);
	buildScreen ();
	showdir();

	/* Loop for DOS commands */
	do {
		_settextposition (22, 30);
		_cleareol();
		_outtext ("Select by number . . . ");
		gets (entry);               /* string input from keyboard */
		choice = atoi (entry);          /* convert to number */
		if ((choice > 0) && (choice < 13))
			processCommand (choice);
	} while (choice != 12);

	/* Restore entry drive and path, then quit */
	_dos_setdrive (curdrive, &n);
	sprintf (oldpath, "CD %s", curdir);
	system (oldpath);
	_settextcolor (LTGRAY);
	_setbkcolor ((long) BLACK);
	_restscrn (0);
} /*-------------------------------------------------*/

void buildScreen (void)     /* Build display and menu */
{
	int row = 7, col = 23, n;

	_clearscreen (_GCLEARSCREEN);
	popShow (&scrn);
	popCenter (&scrn, 1, "* * *  D O S  S H E L L  * * *");
	popHilite (&scrn, 1);
	_settextcolor (GREEN);
	_textbox (5, 20, 19, 60, 2);
	_settextposition (5, 35);
	_outtext (" COMMANDS ");
	_settextcolor (scrn.normal);

	/* Show list of commands */
	for (n = 0; n < 12; n++) {
		if (n == 6) col += 19, row -= 12;   /* column break */
		_settextposition (row+(n*2), col);  /* next position */
		_settextcolor (scrn.hilite);
		_outtextf ("%2d ", n+1);
		_settextcolor (scrn.normal);
		_outtextf (cmd [n]);
	}
} /*------------------------------------------------------*/

void processCommand (int choice)
{                               /* Execute command selected by user */

	char *command;

	popKeep (&scrn);                    /* save screen state */
	switch (choice) {
		case 1:
		case 4:
		case 6:
		case 7: command = getargs (choice);
				_savescrn (0);
				popShow (&dos);
				system (command);
				puts ("\nPress any key to return to shell . . .");
				getch();
				_restscrn (0);
				break;
		case 11: _savescrn (0);
				popShow (&dos);         /* Go to COMMAND.COM */
				system ("\\COMMAND");
				_restscrn (0);
				break;
	}
	popUse (&scrn);
	if ((choice == 1) ||            /* if changed directories */
		(choice == 11))             /* or went to DOS command level */
		showdir();
}/*--------------------------*/

char *noargs (int choice)
							/* Build command line without arguments */
{
	char cmdline [5];

	sprintf (cmdline, "%s", cmd [choice-1]);
	return cmdline;
}/*------------------------------------------*/

char *getargs (int choice)
							/* Build command line with arguments */
{
	static char cmdline [80];
	char arglist [80];

	_savescrn (0);
	popShow (&arg);
	_outtextf ("%s ", cmd [choice-1]);
	gets (arglist);
	sprintf (cmdline, "%s %s", cmd [choice - 1], arglist);
	_restscrn (0);
	return cmdline;
}/*-----------------------------------------------*/

void showdir (void)         /* Show current directory */
{
	char path [64];
	int i;

	popKeep (&scrn);        /* save current window state */
	_settextwindow (1, 1, 25, 80);  /* full screen mode */
	for (i = dir.top; i <= dir.bottom; i++) {
		_settextposition (i, 1);
		_cleareol();            /* clear old dir display area */
	}
	getcwd (path, 64);              /* get current dir */
	i = strlen (path) + 14;
	dir.left = ((80 - i) /2);       /* size new window */
	dir.right = 80 - dir.left;
	popShow (&dir);                 /* show it */
	_outtextf ("  Directory: %s", path);
	popUse (&scrn);                     /* restore old window */
}/*----------------------------*/

